package jp.hishidama.eval;

import jp.hishidama.eval.lex.Lex;

/**
 * ZG[NX.
 * <p>
 * \͂Ɏsꍇ]̎sɎsꍇɃX[B
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @version 2007.03.02
 */
public class EvalException extends RuntimeException {

	/** VAID. */
	private static final long serialVersionUID = 4174576689426433715L;

	/**
	 * ʂ݂Ȃ.
	 * <p>
	 * %0F
	 * </p>
	 */
	public static final int PARSE_NOT_FOUND_END_OP = 1001;

	/** `̉Zq */
	public static final int PARSE_INVALID_OP = 1002;

	/** `̕ */
	public static final int PARSE_INVALID_CHAR = 1003;

	/** ߂̓rŕ񂪏I */
	public static final int PARSE_END_OF_STR = 1004;

	/** ߂Îɕ񂪎cĂ */
	public static final int PARSE_STILL_EXIST = 1005;

	/** ֐ƂĈȂ */
	public static final int PARSE_NOT_FUNC = 1101;

	/**
	 * ֎~ꂽ\bhĂяo.
	 * <p>
	 * l錴F
	 * <ul>
	 * <li>Kvȃ\bhI[o[ChĂȂ</li>
	 * <li>̃NXł́Adlセ̃\bhĂł͂Ȃ</li>
	 * </p>
	 */
	public static final int EXP_FORBIDDEN_CALL = 2001;

	/** ϐƂĈȂ */
	public static final int EXP_NOT_VARIABLE = 2002;

	/** lƂĈȂ */
	public static final int EXP_NOT_NUMBER = 2003;

	/** łȂ */
	public static final int EXP_NOT_LET = 2004;

	/** ϐl擾łȂ */
	public static final int EXP_NOT_VAR_VALUE = 2101;

	/** ϐɑłȂ */
	public static final int EXP_NOT_LET_VAR = 2102;

	/** ϐ` */
	public static final int EXP_NOT_DEF_VAR = 2103;

	/** IuWFNg` */
	public static final int EXP_NOT_DEF_OBJ = 2104;

	/** zl擾łȂ */
	public static final int EXP_NOT_ARR_VALUE = 2201;

	/** zɑłȂ */
	public static final int EXP_NOT_LET_ARR = 2202;

	/** tB[hl擾łȂ */
	public static final int EXP_NOT_FLD_VALUE = 2301;

	/** tB[hɑłȂ */
	public static final int EXP_NOT_LET_FIELD = 2302;

	/** ֐Ăяo̎s */
	public static final int EXP_FUNC_CALL_ERROR = 2401;

	/**
	 * G[bZ[WR[h.
	 * 
	 * @since 2007.03.02
	 */
	protected int msg_code;

	/**
	 * G[bZ[W̃IvV.
	 * 
	 * @since 2007.03.02
	 */
	protected String[] msg_opt;

	/** G[̋N. */
	protected String string;

	/** 񒆂̃G[̋Nʒu. */
	protected int pos = -1;

	/** ߒ̕. */
	protected String word;

	/**
	 * RXgN^[
	 * 
	 * @param msg
	 *            G[bZ[WR[h
	 * @param lex
	 *            ͈ʒu
	 * @since 2007.03.02
	 */
	public EvalException(int msg, Lex lex) {
		this(msg, null, lex);
	}

	/**
	 * RXgN^[
	 * 
	 * @param msg
	 *            G[bZ[WR[h
	 * @param opt
	 *            G[bZ[WIvV
	 * @param lex
	 *            ͈ʒu
	 * @since 2007.03.02
	 */
	public EvalException(int msg, String[] opt, Lex lex) {
		this.msg_code = msg;
		this.msg_opt = opt;
		if (lex != null) {
			this.string = lex.getString();
			this.pos = lex.getPos();
			this.word = lex.getWord();
		}
	}

	/**
	 * RXgN^[
	 * 
	 * @param msg
	 *            G[bZ[W
	 * @param string
	 *            Ώە
	 * @param pos
	 *            ʒu
	 * @param e
	 *            ƂȂO
	 * @since 2007.03.02
	 */
	public EvalException(int msg, String word, String string, int pos,
			Throwable e) {
		while (e != null) {
			if (e.getClass() == RuntimeException.class && e.getCause() != null) {
				e = e.getCause();
			} else
				break;
		}
		if (e != null)
			super.initCause(e);
		this.msg_code = msg;
		this.string = string;
		this.pos = pos;
		this.word = word;
	}

	/**
	 * G[R[h擾
	 * 
	 * @return G[R[h
	 * @since 2007.03.02
	 */
	public int getErrorCode() {
		return msg_code;
	}

	/**
	 * bZ[Wt擾
	 * 
	 * @return t
	 * @since 2007.03.02
	 */
	public String[] getOption() {
		return msg_opt;
	}

	/**
	 * Ώێʎq擾
	 * 
	 * @return 
	 * @since 2007.03.02
	 */
	public String getWord() {
		return word;
	}

	/**
	 * ͑O擾
	 * 
	 * @return 
	 * @since 2007.03.02
	 */
	public String getString() {
		return string;
	}

	/**
	 * G[ʒu擾
	 * 
	 * @return ʒu
	 * @since 2007.03.02
	 */
	public int getPos() {
		return pos;
	}

	/**
	 * R[hʃbZ[W擾
	 * 
	 * @param code
	 *            G[R[h
	 * @return 僁bZ[WitH[}bgtj
	 * @since 2007.03.02
	 */
	public static String getErrCodeMessage(int code) {
		switch (code) {
		case PARSE_NOT_FOUND_END_OP:
			return "Zqu%0v݂܂B";
		case PARSE_INVALID_OP:
			return "Zq̕@G[łB";
		case PARSE_INVALID_CHAR:
			return "Ή̎ʎqłB";
		case PARSE_END_OF_STR:
			return "̉߂̓rŕ񂪏IĂ܂B";
		case PARSE_STILL_EXIST:
			return "̉߂I܂񂪎cĂ܂B";
		case PARSE_NOT_FUNC:
			return "֐ƂĎgpł܂B";
		case EXP_FORBIDDEN_CALL:
			return "֎~Ă郁\bhĂяo܂B";
		case EXP_NOT_VARIABLE:
			return "ϐƂĎgpł܂B";
		case EXP_NOT_NUMBER:
			return "lƂĎgpł܂B";
		case EXP_NOT_LET:
			return "ł܂B";
		case EXP_NOT_VAR_VALUE:
			return "ϐ̒l擾ł܂B";
		case EXP_NOT_LET_VAR:
			return "ϐɑł܂B";
		case EXP_NOT_DEF_VAR:
			return "ϐ`łB";
		case EXP_NOT_DEF_OBJ:
			return "IuWFNg`łB";
		case EXP_NOT_ARR_VALUE:
			return "z̒l擾ł܂B";
		case EXP_NOT_LET_ARR:
			return "zɑł܂B";
		case EXP_NOT_FLD_VALUE:
			return "tB[h̒l擾ł܂B";
		case EXP_NOT_LET_FIELD:
			return "tB[hɑł܂B";
		case EXP_FUNC_CALL_ERROR:
			return "֐̌ĂяoɎs܂B";
		default:
			return "G[܂B";
		}
	}

	/**
	 * ftHgtH[}bg擾
	 * 
	 * @param msgFmt
	 *            僁bZ[W
	 * @return bZ[WtH[}bg
	 * @see #toString(String)
	 * @since 2007.03.02
	 */
	public String getDefaultFormat(String msgFmt) {
		StringBuffer fmt = new StringBuffer(128);
		fmt.append(msgFmt);

		boolean bWord = false;
		if (word != null && word.length() > 0) {
			bWord = true;
			if (word.equals(string))
				bWord = false;
		}
		if (bWord) {
			fmt.append(" word=u%wv");
		}

		if (pos >= 0) {
			fmt.append(" pos=%p");
		}
		if (string != null) {
			fmt.append(" string=u%sv");
		}
		if (getCause() != null) {
			fmt.append(" cause by %e");
		}

		return fmt.toString();
	}

	public String toString() {
		String msg = getErrCodeMessage(msg_code);
		String fmt = getDefaultFormat(msg);
		return toString(fmt);
	}

	/**
	 * G[bZ[W擾.
	 * <p>
	 * tH[}bgɃbZ[WҏWB <table border="1">
	 * <tr>
	 * <td>%0`9</td>
	 * <td>t0`9ԁB݂Ȃꍇ͋󕶎</td>
	 * </tr>
	 * <tr>
	 * <td>%c</td>
	 * <td>G[R[h</td>
	 * </tr>
	 * <tr>
	 * <td>%s</td>
	 * <td>͑O̕</td>
	 * </tr>
	 * <tr>
	 * <td>%p</td>
	 * <td>G[A͑Öʒu</td>
	 * </tr>
	 * <tr>
	 * <td>%w</td>
	 * <td>G[̌ƂȂ</td>
	 * </tr>
	 * <tr>
	 * <td>%e</td>
	 * <td>炩̗OŃG[ƂȂꍇ́A̗O</td>
	 * </tr>
	 * <tr>
	 * <td>%%</td>
	 * <td>u%v</td>
	 * </tr>
	 * </table>
	 * </p>
	 * 
	 * @param fmt
	 *            tH[}bg
	 * @return G[bZ[W
	 * @since 2007.03.02
	 */
	public String toString(String fmt) {
		StringBuffer sb = new StringBuffer(256);
		int len = fmt.length();
		for (int i = 0; i < len; i++) {
			char c = fmt.charAt(i);
			if (c != '%') {
				sb.append(c);
			} else {
				if (i + 1 >= len) {
					sb.append(c);
					break;
				}
				c = fmt.charAt(++i);
				switch (c) {
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':
					int n = c - '0';
					if (msg_opt != null && n < msg_opt.length) {
						sb.append(msg_opt[n]);
					}
					break;
				case 'c':
					sb.append(msg_code);
					break;
				case 'w':
					sb.append(word);
					break;
				case 'p':
					sb.append(pos);
					break;
				case 's':
					sb.append(string);
					break;
				case 'e':
					sb.append(getCause());
					break;
				case '%':
					sb.append('%');
					break;
				default:
					sb.append('%');
					sb.append(c);
					break;
				}
			}
		}
		return sb.toString();
	}
}
