package jp.hishidama.eval.exp;

import jp.hishidama.eval.EvalException;

/**
 * zNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @since 2006.10.27
 */
public class ArrayExpression extends Col2OpeExpression {

	public ArrayExpression() {
		setOperator("[");
		setEndOperator("]");
	}

	protected ArrayExpression(ArrayExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new ArrayExpression(this, s);
	}

	public long evalLong() {
		try {
			return share.var.evalLong(getVariable());
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_ARR_VALUE,
					toString(), string, pos, e);
		}
	}

	public double evalDouble() {
		try {
			return share.var.evalDouble(getVariable());
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_ARR_VALUE,
					toString(), string, pos, e);
		}
	}

	public Object evalObject() {
		return getVariable();
	}

	protected Object getVariable() {
		Object obj = expl.getVariable();
		if (obj == null) {
			throw new EvalException(EvalException.EXP_NOT_DEF_OBJ, expl
					.toString(), string, pos, null);
		}
		int index = (int) expr.evalLong();
		try {
			return share.var.getObject(obj, index);
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_ARR_VALUE,
					toString(), string, pos, e);
		}
	}

	protected void let(Object val, int pos) {
		Object obj = expl.getVariable();
		if (obj == null) {
			throw new EvalException(EvalException.EXP_NOT_DEF_OBJ, expl
					.toString(), string, pos, null);
		}
		int index = (int) expr.evalLong();
		try {
			share.var.setValue(obj, index, val);
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_LET_ARR, toString(),
					string, pos, e);
		}
	}

	protected AbstractExpression replaceVar() {
		expl = expl.replaceVar();
		expr = expr.replace();
		return share.repl.replaceVar2(this);
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(expl.toString());
		sb.append('[');
		sb.append(expr.toString());
		sb.append(']');
		return sb.toString();
	}
}
