package jp.hishidama.eval.exp;

import jp.hishidama.eval.EvalException;

/**
 * tB[hNX.
 * <p>
 * NX̃tB[huobj.fieldv
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @since 2007.02.14
 */
public class FieldExpression extends Col2OpeExpression {

	public FieldExpression() {
		setOperator(".");
	}

	protected FieldExpression(FieldExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new FieldExpression(this, s);
	}

	public long evalLong() {
		try {
			return share.var.evalLong(getVariable());
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_NUMBER, toString(),
					string, pos, e);
		}
	}

	public double evalDouble() {
		try {
			return share.var.evalDouble(getVariable());
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_NUMBER, toString(),
					string, pos, e);
		}
	}

	public Object evalObject() {
		return getVariable();
	}

	protected Object getVariable() {
		Object obj = expl.getVariable();
		if (obj == null) {
			throw new EvalException(EvalException.EXP_NOT_DEF_OBJ, expl
					.toString(), string, pos, null);
		}
		String word = expr.getWord();
		try {
			return share.var.getObject(obj, word);
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_FLD_VALUE,
					toString(), string, pos, e);
		}
	}

	protected void let(Object val, int pos) {
		Object obj = expl.getVariable();
		if (obj == null) {
			throw new EvalException(EvalException.EXP_NOT_DEF_OBJ, expl
					.toString(), string, pos, null);
		}
		String word = expr.getWord();
		try {
			share.var.setValue(obj, word, val);
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_LET_FIELD,
					toString(), string, pos, e);
		}
	}

	protected AbstractExpression replace() {
		expl = expl.replaceVar();
		// expr = expr.replace();
		return share.repl.replace2(this);
	}

	protected AbstractExpression replaceVar() {
		expl = expl.replaceVar();
		// expr = expr.replace();
		return share.repl.replaceVar2(this);
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(expl.toString());
		sb.append('.');
		sb.append(expr.toString());
		return sb.toString();
	}
}
