package jp.hishidama.eval.exp;

import java.util.ArrayList;
import java.util.List;

import jp.hishidama.eval.EvalException;

/**
 * ֐NX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @version 2007.03.02
 */
public class FunctionExpression extends Col1Expression {

	/**
	 * ֐CX^X.
	 * 
	 * @param x
	 *            ֐A邢̓IuWFNg.֐
	 * @param args
	 *            
	 * @param prio
	 *            D揇
	 * @return CX^X
	 */
	public static AbstractExpression create(AbstractExpression x,
			AbstractExpression args, int prio, ShareExpValue share) {
		AbstractExpression obj;
		if (x instanceof VariableExpression) {
			obj = null;
		} else if (x instanceof FieldExpression) {
			FieldExpression f = (FieldExpression) x;
			obj = f.expl;
			x = f.expr;
		} else {
			throw new EvalException(EvalException.PARSE_NOT_FUNC, x.toString(),
					x.string, x.pos, null);
		}
		String name = x.getWord();
		FunctionExpression f = new FunctionExpression(obj, name);
		f.setExpression(args);
		f.setPos(x.string, x.pos);
		f.setPriority(prio);
		f.share = share;
		return f;
	}

	/**
	 * \bh̑ĂIuWFNg.
	 * <p>
	 * ꍇnullB
	 * </p>
	 * 
	 * @since 2007.02.15
	 */
	protected AbstractExpression target;

	/** ֐. */
	String name;

	public FunctionExpression() {
		setOperator("(");
		setEndOperator(")");
	}

	/**
	 * RXgN^[.
	 * 
	 * @param obj
	 *            IuWFNg
	 * @param word
	 *            ֐
	 */
	public FunctionExpression(AbstractExpression obj, String word) {
		this();
		target = obj;
		name = word;
	}

	protected FunctionExpression(FunctionExpression from, ShareExpValue s) {
		super(from, s);
		if (from.target != null) {
			target = from.target.dup(s);
		}
		name = from.name;
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new FunctionExpression(this, s);
	}

	public long evalLong() {
		Object obj = null;
		if (target != null) {
			obj = target.getVariable();
		}
		List args = evalArgsLong();
		try {
			Long[] arr = new Long[args.size()];
			return share.func.evalLong(obj, name, (Long[]) args.toArray(arr));
		} catch (EvalException e) {
			throw e;
		} catch (Throwable e) {
			throw new EvalException(EvalException.EXP_FUNC_CALL_ERROR, name,
					string, pos, e);
		}
	}

	public double evalDouble() {
		Object obj = null;
		if (target != null) {
			obj = target.getVariable();
		}
		List args = evalArgsDouble();
		try {
			Double[] arr = new Double[args.size()];
			return share.func.evalDouble(obj, name, (Double[]) args
					.toArray(arr));
		} catch (EvalException e) {
			throw e;
		} catch (Throwable e) {
			throw new EvalException(EvalException.EXP_FUNC_CALL_ERROR, name,
					string, pos, e);
		}
	}

	public Object evalObject() {
		Object obj = null;
		if (target != null) {
			obj = target.getVariable();
		}
		List args = evalArgsObject();
		try {
			Object[] arr = new Object[args.size()];
			return share.func.evalObject(obj, name, args.toArray(arr));
		} catch (EvalException e) {
			throw e;
		} catch (Throwable e) {
			throw new EvalException(EvalException.EXP_FUNC_CALL_ERROR, name,
					string, pos, e);
		}
	}

	private List evalArgsLong() {
		List args = new ArrayList();
		if (exp != null) {
			exp.evalArgsLong(args);
		}
		return args;
	}

	private List evalArgsDouble() {
		List args = new ArrayList();
		if (exp != null) {
			exp.evalArgsDouble(args);
		}
		return args;
	}

	private List evalArgsObject() {
		List args = new ArrayList();
		if (exp != null) {
			exp.evalArgsObject(args);
		}
		return args;
	}

	protected Object getVariable() {
		return evalObject();
	}

	protected long operateLong(long val) {
		throw new RuntimeException("̊֐Ă΂Ă͂ȂBTuNXŎv");
	}

	protected double operateDouble(double val) {
		throw new RuntimeException("̊֐Ă΂Ă͂ȂBTuNXŎv");
	}

	protected void search() {
		share.srch.search(this);
		if (share.srch.end())
			return;

		if (share.srch.searchFunc_begin(this))
			return;
		if (share.srch.end())
			return;

		if (target != null) {
			target.search();
			if (share.srch.end())
				return;
		}

		if (share.srch.searchFunc_2(this))
			return;
		if (share.srch.end())
			return;

		if (exp != null) {
			exp.search();
			if (share.srch.end())
				return;
		}

		share.srch.searchFunc_end(this);
	}

	protected AbstractExpression replace() {
		if (target != null) {
			target = target.replace();
		}
		if (exp != null) {
			exp = exp.replace();
		}
		return share.repl.replaceFunc(this);
	}

	public boolean equals(Object obj) {
		if (obj instanceof FunctionExpression) {
			FunctionExpression e = (FunctionExpression) obj;
			return name.equals(e.name) && equals(target, e.target)
					&& equals(exp, e.exp);
		}
		return false;
	}

	private static boolean equals(AbstractExpression e1, AbstractExpression e2) {
		if (e1 == null) {
			return e2 == null;
		}
		if (e2 == null)
			return false;
		return e1.equals(e2);
	}

	public int hashCode() {
		int t = (target != null) ? target.hashCode() : 0;
		int a = (exp != null) ? exp.hashCode() : 0;
		return name.hashCode() ^ t ^ (a * 2);
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		if (target != null) {
			sb.append(target.toString());
			sb.append('.');
		}
		sb.append(name);
		sb.append('(');
		if (exp != null) {
			sb.append(exp.toString());
		}
		sb.append(')');
		return sb.toString();
	}
}
