package jp.hishidama.eval.exp;

import jp.hishidama.eval.EvalException;
import jp.hishidama.eval.lex.Lex;

/**
 * lNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 */
public class NumberExpression extends WordExpression {

	/**
	 * CX^Xilpj.
	 * 
	 * @param lex
	 *            ߒʒu
	 * @param prio
	 *            D揇
	 * @return CX^X
	 * @since 2007.02.15
	 */
	public static AbstractExpression create(Lex lex, int prio) {
		AbstractExpression exp = new NumberExpression(lex.getWord());
		exp.setPos(lex.getString(), lex.getPos());
		exp.setPriority(prio);
		exp.share = lex.getShare();
		return exp;
	}

	public NumberExpression(String str) {
		super(str);
	}

	protected NumberExpression(NumberExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new NumberExpression(this, s);
	}

	public static NumberExpression create(AbstractExpression from, String word) {
		NumberExpression n = new NumberExpression(word);
		n.string = from.string;
		n.pos = from.pos;
		n.prio = from.prio;
		n.share = from.share;
		return n;
	}

	public long evalLong() {
		try {
			return jp.hishidama.util.NumberUtil.parseLong(word);
		} catch (Exception e) {
		}
		try {
			return Long.parseLong(word);
		} catch (Exception e) {
		}
		try {
			return (long) Double.parseDouble(word);
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_NUMBER, word, string,
					pos, e);
		}
	}

	public double evalDouble() {
		try {
			return Double.parseDouble(word);
		} catch (Exception e) {
			try {
				return jp.hishidama.util.NumberUtil.parseLong(word);
			} catch (Exception e2) {
			}
			throw new EvalException(EvalException.EXP_NOT_NUMBER, word, string,
					pos, e);
		}
	}

	public Object evalObject() {
		try {
			return new Long(jp.hishidama.util.NumberUtil.parseLong(word));
		} catch (Exception e) {
		}
		try {
			return Long.valueOf(word);
		} catch (Exception e) {
		}
		try {
			return Double.valueOf(word);
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_NUMBER, word, string,
					pos, e);
		}
	}
}
