package jp.hishidama.eval.exp;

import jp.hishidama.eval.EvalException;
import jp.hishidama.eval.lex.Lex;

/**
 * ϐNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @version 2007.02.15
 */
public class VariableExpression extends WordExpression {

	/**
	 * CX^Xiʎqpj.
	 * 
	 * @param lex
	 *            ߒʒu
	 * @param prio
	 *            D揇
	 * @return CX^X
	 */
	public static AbstractExpression create(Lex lex, int prio) {
		AbstractExpression exp = new VariableExpression(lex.getWord());
		exp.setPos(lex.getString(), lex.getPos());
		exp.setPriority(prio);
		exp.share = lex.getShare();
		return exp;
	}

	public VariableExpression(String str) {
		super(str);
	}

	protected VariableExpression(VariableExpression from, ShareExpValue s) {
		super(from, s);
	}

	public AbstractExpression dup(ShareExpValue s) {
		return new VariableExpression(this, s);
	}

	public long evalLong() {
		try {
			return share.var.evalLong(getVarValue());
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_NUMBER, word, string,
					pos, e);
		}
	}

	public double evalDouble() {
		try {
			return share.var.evalDouble(getVarValue());
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_NUMBER, word, string,
					pos, e);
		}
	}

	public Object evalObject() {
		return getVarValue();
	}

	protected void let(Object val, int pos) {
		String name = getWord();
		try {
			share.var.setValue(name, val);
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_LET_VAR, name,
					string, pos, e);
		}
	}

	/**
	 * ϐl擾.
	 * 
	 * @return ϐliKnullȊOj
	 * @throws EvalException
	 *             ϐƂ
	 * @version 2007.02.09
	 */
	private Object getVarValue() {
		String word = getWord();

		Object val;
		try {
			val = share.var.getObject(word);
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_VAR_VALUE, word,
					string, pos, e);
		}
		if (val == null) {
			throw new EvalException(EvalException.EXP_NOT_DEF_VAR, word,
					string, pos, null);
		}
		return val;
	}

	protected Object getVariable() {
		try {
			return share.var.getObject(word);
		} catch (EvalException e) {
			throw e;
		} catch (Exception e) {
			throw new EvalException(EvalException.EXP_NOT_VARIABLE, word,
					string, pos, null);
		}
	}
}
