package jp.hishidama.eval.func;

import java.lang.reflect.Method;

import jp.hishidama.eval.func.Function;

/**
 * lZ֐(long)Tv.
 * <p>
 * Math̊e֐̂Along^̊֐ĂяoTvB
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @see java.lang.Math
 * @version 2007.02.15
 */
public class MathFunction implements Function {

	public long evalLong(Object object, String name, Long[] args)
			throws Throwable {
		Class[] types = new Class[args.length];
		for (int i = 0; i < types.length; i++) {
			types[i] = long.class;
		}

		Method m = Math.class.getMethod(name, types);
		Object ret = m.invoke(null, args);
		// return Long.parseLong(ret.toString());
		return ((Long) ret).longValue();
	}

	public double evalDouble(Object object, String name, Double[] args)
			throws Throwable {
		Class[] types = new Class[args.length];
		for (int i = 0; i < types.length; i++) {
			types[i] = double.class;
		}

		Method m = Math.class.getMethod(name, types);
		Object ret = m.invoke(null, args);
		// return Double.parseDouble(ret.toString());
		return ((Double) ret).doubleValue();
	}

	public Object evalObject(Object object, String name, Object[] args)
			throws Throwable {
		Class[] types = new Class[args.length];
		for (int i = 0; i < types.length; i++) {
			Class c = args[i].getClass();
			if (Double.class.isAssignableFrom(c)) {
				c = Double.TYPE;
			} else if (Float.class.isAssignableFrom(c)) {
				c = Float.TYPE;
			} else if (Integer.class.isAssignableFrom(c)) {
				c = Integer.TYPE;
			} else if (Number.class.isAssignableFrom(c)) {
				c = Long.TYPE;
			}
			types[i] = c;
		}

		Method m = Math.class.getMethod(name, types);
		return m.invoke(null, args);
	}

}
