package jp.hishidama.eval.rule;

import java.util.*;

import jp.hishidama.eval.EvalException;
import jp.hishidama.eval.Expression;
import jp.hishidama.eval.Rule;
import jp.hishidama.eval.exp.AbstractExpression;
import jp.hishidama.eval.exp.ShareExpValue;
import jp.hishidama.eval.lex.Lex;
import jp.hishidama.eval.lex.LexFactory;
import jp.hishidama.eval.oper.Operator;
import jp.hishidama.eval.ref.Refactor;
import jp.hishidama.eval.srch.Search;
import jp.hishidama.eval.var.Variable;

/**
 * [ʏNX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/eval.html">Ђ</a>
 * @version 2007.02.20
 */
public class ShareRuleValue extends Rule {
	public AbstractRule topRule;

	public AbstractRule funcArgRule;

	/**
	 * Lex쐬t@Ng[.
	 */
	public LexFactory lexFactory;

	/**
	 * ZqQ.
	 * <p>
	 * ͂ŉZqƔF镶B Zq̕ɂĔz𕪂ĂB iZqɃ}b`ׁj<br>
	 * StringListB
	 * </p>
	 */
	protected List[] opeList = new List[4];

	/** ۊʂ̉Zq */
	public AbstractExpression paren;

	public Expression parse(String str) {
		if (str == null)
			return null;
		if (str.trim().length() <= 0) {
			return new EmptyExpression();
		}

		ShareExpValue exp = new ShareExpValue();
		AbstractExpression x = parse(str, exp);

		exp.setAbstractExpression(x);
		return exp;
	}

	/**
	 * \́ipj
	 * 
	 * @param str
	 *            ͑Ώە
	 * @param exp
	 *            ʏ
	 * @return \͖
	 * @since 2007.02.20
	 */
	public AbstractExpression parse(String str, ShareExpValue exp) {
		if (str == null)
			return null;

		Lex lex = lexFactory.create(str, opeList, this, exp);
		lex.check();

		AbstractExpression x = topRule.parse(lex);
		if (lex.getType() != Lex.TYPE_EOF) {
			throw new EvalException(EvalException.PARSE_STILL_EXIST, lex);
		}
		return x;
	}

	/**
	 * ͑ΏۂƂɕԂExpression
	 */
	class EmptyExpression extends Expression {

		public long evalLong() {
			return 0;
		}

		public double evalDouble() {
			return 0;
		}

		public Object eval() {
			return null;
		}

		public void optimizeLong(Variable var) {
		}

		public void optimizeDouble(Variable var) {
		}

		public void optimize(Variable var, Operator oper) {
		}

		public void search(Search srch) {
		}

		public void refactorName(Refactor ref) {
		}

		public void refactorFunc(Refactor ref, Rule rule) {
		}

		public Expression dup() {
			return new EmptyExpression();
		}

		public boolean same(Expression obj) {
			if (obj instanceof EmptyExpression) {
				return true;
			}
			return false;
		}

		public String toString() {
			return "";
		}
	}
}
